{H+ $SMARTLINK+}
Unit PTK;
{A Unit for communicating with wish

        Copyright (C) 2001  A.J. Venter

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
--------------------------------------------
A.J. Venter (ddt@vukanet.co.za)
--------------------------------------------
}
Interface
Uses Linux,safetemp;

VAR PID :LONGINT;

Const basedir : string = '/tmp/';
      Wishexec: string = '#!/usr/bin/wish';
      nothing = '/**NOTHING**\';
      
Type Wish = Object
	WFile:Text;
	FileName:String;
	Name :String;
	PIDstring:String;
	StreamI,StreamO	: text;
	procedure Init(WindowName:String);
	procedure command(theCommand:String);
	procedure draw;
	function killed:boolean;
	
	Function said:String;
	procedure destroy;
    end;
    
    
Implementation


Procedure wish.Init(windowName:String);
Begin
    name := WindowName;
    filename := baseDir + safe_temp(windowName);  {Create a temp file for the window}
    assign (WFile,filename);
    rewrite (Wfile);
    
    
    {Stick the wish init headers into the temp file}
    writeln (Wfile,wishexec);
    
    
    
    shell ('chmod a+x ' + filename); {Have to fix this to use the chmod function}	
    
    close (wfile); {Close the file}
    
End;

procedure wish.command(TheCommand:String);
Begin
    assign (Wfile,FileName);
    append (Wfile);
    Writeln (Wfile,thecommand);
    close (Wfile);
end;

procedure wish.draw;
Begin
    PID := assignstream (StreamI,StreamO,filename + ' -name ' + Name); {Open our pseudoscript}
    str (PID,PIDString);
end;


function wish.killed:boolean;
Var Ik,Ok,Ek :Text;
    PIDk :Longint;
    Sk	:String;
    
Begin

PIDk := assignstream (Ik,Ok,Ek,'/sbin/pidof -x wish');
readln (Ik,Sk);
If pos(PidString,SK) = 0 then Killed := True else Killed := False;
end;    



function wish.said:String;
Var StrNG:String;
Begin
{Returns Wish outputs, Nothing if no output, 'Quit' if wish is dead}
    If killed then
    said := 'Quit' else
    Begin
    
{Return the last output from wish}
        {$I-} {turn off error checking in case no output yet}
	readln(StreamI,StrNG);
        {$I+}
	    If IOResult <> 0 then {No output yet would cause this}
	    Said := NOTHING {OUR NO OUTPUT YET FLAG VALUE}
        else
	    Said := Strng; {Otherwize return the output}
    
End;
end;

    


procedure wish.destroy;
Begin
    {Kill the window}
    shell ('kill -9 ' +  PIDstring);
    
    {Remove the tempFile}
    shell ('rm -fr ' + FileName);
    
End;


End.